<template>
  <div class="mermaid-view"></div>
</template>

<script>

const mermaidFiles = {}

function importAll (r) {
  r.keys().forEach(key => {
    // Remove the first dot ('.') at the start of the string
    const fileName = key.slice(1)
    // Add to mermaidFiles
    mermaidFiles[fileName] = r(key).default
    console.log('key', key)
  })
}

const ctx = require.context('../../', true, /^(?!node_modules).*\.mmd$/)

importAll(ctx)

export default {
  beforeMount() {
    import("mermaid/dist/mermaid").then(m => {
      m.initialize({
        theme: null, // disable any theme
        startOnLoad: true,
        flowchart: {
          useMaxWidth: true,
          htmlLabels: true,
          rankSpacing: 14,
          nodeSpacing: 10,
          curve: 'linear'
          // padding: 1 // Does not work actually...
        },
        sequence: {
          mirrorActors: false,
          bottomMarginAdj: 2,
          noteAlign: 'left'
        }
      })
      // m.init('div.language-mermaid>pre>code');
      this.mmdContent = mermaidFiles[this.filePath]
      this.$el.innerHTML = this.mmdContent
      m.init(this.$el)
      // Use some javascript here
      // For flowcharts
      if (this.mmdContent.match(/^graph/)) {
        const subgraphs = this.$el.firstChild.querySelectorAll('.cluster')
        subgraphs.forEach((sg) => {
          // Round corners rect
          sg.querySelector('rect').setAttribute('rx', '4px')
          sg.querySelector('rect').setAttribute('ry', '4px')
          // Move up label
          const label = sg.querySelector('.label')
          // Find x value
          // let xValue = label.attributes.transform.value.match(/translate\((.*), (.*)\)/)[1]
          // For left aligned label: xValue = -(parentWidth / 2) + (labelWidth / 2)
          console.log(label)
          let labelWidth = label.querySelector('div').clientWidth
          let xValue = -(label.parentElement.querySelector('rect').attributes.width.value / 2) + (labelWidth / 2)
          // Find y value
          let yValue = label.attributes.transform.value.match(/translate\((.*), (.*)\)/)[2]
          // Set attribute and move up in y axis
          label.setAttribute('transform', `translate(${xValue}, ${yValue - 24})`)
        })
      }
    })
  },
  data () {
    return {
      mmdContent: ''
    }
  },
  props: {
    filePath: {
      type: String,
      default: ''
    }
  }
}
</script>

<style lang="stylus">
// Mermaid
div.mermaid-view
  width: 100%;
  background-color: inherit
  border-radius: 4px
  margin-top: -3.1rem
  padding-top: 4.6rem
  // All
  *
    font-family: Arial, sans-serif 
    font-size: 1rem 
    color: $ms-white
  // svg element
  svg:first-child
    // border: 1px solid $ms-secondary-dark
    border-radius: 4px

// Flowchart
div.mermaid-view.mermaid-flowchart
  // Fontawesome icons
  .fa
    font-family: "Font Awesome 5 Free" 
  // svg element
  svg:first-child
    // Nodes
    .node > rect,
    .node > polygon
      fill: $ms-blue 
      stroke: none 
    .node .label div
      color: $ms-dark 
      // Fontawesome icon
      i
        color: $ms-dark 
    .node.invertedtheme 
      > rect
        fill: transparent 
        stroke: $ms-blue 
        stroke-width: 2px 
      .label div
        color: $ms-blue 
    .node.disabledNode 
      > rect
        fill: transparent 
        stroke: $ms-third-dark 
        stroke-width: 2px 
      .label div
        color: grey 
    .node.greenNode 
      > rect
        fill: $ms-green
    // Subgraphs
    .cluster 
      > rect
        stroke: $ms-third-dark 
      .label div
        color: grey
        text-shadow: 0 0 4px $ms-dark
    // EdgePaths
    .edgePath
      > path 
        stroke: $ms-blue
      > defs marker
        fill: $ms-blue
    // Edgelabel
    .edgeLabel
      .label > rect
        fill: transparent !important
      .label div span
        color: grey !important
// Flowchart
div.mermaid-view.mermaid-sequence

  .actor // Style for the actor box at the top of the diagram.
    fill: $ms-dark
    stroke: $ms-blue
    stroke-width: 2px
  text.actor // Styles for text in the actor box at the top of the diagram.
    fill: $ms-white
    stroke: none
  .activation0
    fill: $ms-green
    stroke: $ms-secondary-dark
  .actor-line // The vertical line for an actor.
    stroke: $ms-blue
    opacity: 1
  .messageLine0 // Styles for the solid message line.
    stroke: $ms-blue
  .messageLine1 // Styles for the dotted message line.
    stroke: $ms-blue
  #arrowhead
    fill: $ms-blue
  #crosshead path
    fill: $ms-blue
    stroke: $ms-blue
  .messageText // Defines styles for the text on the message arrows.
    fill: $ms-blue
  .labelBox // Defines styles label to left in a loop.
    display: none
  .labelText // Styles for the text in label for loops.
    display: none
  .loopText // Styles for the text in the loop box.
    fill: $ms-white
  .loopLine //Defines styles for the lines in the loop box.
    stroke: grey
    fill: $ms-secondary-dark
  .note // Styles for the note box.
    fill: $ms-secondary-dark
    stroke: $ms-third-dark
  .noteText
    fill: $ms-white
  rect.rect
    stroke: $ms-third-dark
    fill: transparent
</style>